﻿using System;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;

namespace ThinkGeoMemTest
{

    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, INotifyPropertyChanged
    {
        private TextBlock _myContentSelection;
        private UIElement _myContent;

        public MainWindow()
        {
            InitializeComponent();

            DataContext = this;
        }

        public UIElement MyContent
        {
            get { return _myContent; }
            set { _myContent = value; OnPropertyChanged(); }
        }

        public TextBlock MyContentSelection
        {
            get { return _myContentSelection; }
            set
            {
                _myContentSelection = value;
                switch (_myContentSelection.Text)
                {
                    case "":
                        if(MyContent is IDisposable)
                            (MyContent as IDisposable).Dispose();

                        MyContent = null;
                        break;
                    case "2":
                        MyContent = null;
                        break;
                    case "TestControl":
                        MyContent = new TestControl(); //HUGE
                        break;
                    case "TestControl2":
                        MyContent = new TestControl2();
                        break;
                    case "ThinkGeoMapTestControl":
                        MyContent = new ThinkGeoMapTestControl();
                        break;
                }

                GC.Collect(); 
                Task.Run(() => { Thread.Sleep(10); GC.Collect(); } )
                    .ContinueWith((_) =>
                    {
                        Thread.Sleep(10); GC.Collect();
                        OnPropertyChanged("MemFootprint");
                    });

                OnPropertyChanged("MemFootprint");
            }
        }
        public string MemFootprint { get { return string.Format("Usage: {0:F1} MB", ((float)GC.GetTotalMemory(true)) / 1000000); } }

        #region
        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion
    }
}
